diff -ruN yapet-0.4.bak/csv2yapet/csvimport.cc yapet-0.4/csv2yapet/csvimport.cc
--- yapet-0.4.bak/csv2yapet/csvimport.cc	2009-07-08 18:47:47.000000000 +0200
+++ yapet-0.4/csv2yapet/csvimport.cc	2009-07-18 21:49:28.248643178 +0200
@@ -57,38 +57,27 @@
 #include <file.h>
 
 /**
- * Count the number of separators on the line.
+ * Removes the double quotes at the beginning and any escaped double quotes.
  *
- * @param s the line
+ * @param str the string to be cleaned up.
  *
- * @return the number of separators.
- */
-unsigned int
-CSVImport::countSeparator(const std::string& s) const {
-    unsigned int c = 0;
-    std::string::size_type pos = 0;
-    while ( (pos = s.find(separator, pos)) != std::string::npos ) {
-	c++;
-	pos++;
-    }
-    return c;
-}
-
-/**
- * Returns a vector holding the character positions of the separators.
- *
- * @param line the line
- *
- * @param posvec the vector filled with the positions
+ * @return the string \c str passed will be modified.
  */
 void
-CSVImport::getSeparatorPos(const std::string& line,
-			   std::vector<std::string::size_type>& posvec) const {
-    posvec.clear();
-    std::string::size_type pos = 0;
-    while ( (pos = line.find(separator, pos)) != std::string::npos ) {
-	posvec.push_back(pos);
-	pos++;
+CSVImport::cleanupValue(std::string& str) {
+    if (str.length() == 0) return;
+
+    if (str.at(0) == '"')
+	str = str.erase(0, 1);
+
+    if (str.at(str.length()-1) == '"')
+	str = str.erase(str.length()-1, 1);
+
+    std::string::size_type pos=0;
+    while ( ( pos = str.find("\"\"", pos)) != std::string::npos ) {
+	str.erase(pos,1);
+	if (pos + 1 < str.length() )
+	    pos++;
     }
 }
 
@@ -159,7 +148,7 @@
 	NUM_SEPARATORS;
 
     // used for logging purpose
-    unsigned int num_fields = NUM_SEPARATORS + 1;
+    const unsigned int num_fields = NUM_SEPARATORS + 1;
     char num_fields_str[5];
     snprintf(num_fields_str, 5, "%u", num_fields);
 
@@ -168,19 +157,67 @@
     std::list<YAPET::PartDec> list;
 
     char line[max_len];
-    std::vector<std::string::size_type> seppos;
+    // Holds the line number count
     unsigned long lineno = 0;
+    // Flag indicating whether we're in a quote or not
+    bool inquote = false;
+    // Array holding the field values of the csv file
+    std::string field_values[num_fields];
+    // Integer indicating which field has to be filled
+    int current_field = 0;
+    // Number of delimiters found per line
+    int num_sep_found = 0;
+    // The iterator for scanning the line character by character
+    std::string::size_type it=0;
+
     while (csvfile.getline(line, max_len) ) {
 	lineno++;
 	std::string l(line);
-	if (countSeparator(l) > NUM_SEPARATORS) {
-	    std::string tmp("Too many fields. Expected ");
-	    tmp += num_fields_str;
-	    tmp += " fields.";
-	    logError(lineno, tmp );
-	    continue;
+	// integer pointing to the last delimiter found
+	std::string::size_type last_sep = 0;
+
+	if (!inquote) {
+	    current_field = 0;
+	    num_sep_found = 0;
+	    for (unsigned int i = 0; i < num_fields; i++)
+		field_values[i].clear();
+	}
+
+	// Indicate scanning error
+	bool scan_error = false;
+	for (it=0; it < l.length(); it++) {
+	    // Flip the inquote flag when encountering a double quote
+	    if (l.at(it) == '"') {
+		inquote = !inquote;
+	    }
+
+	    if (!inquote && (l.at(it) == separator) ) {
+		num_sep_found++;
+		if (num_sep_found > NUM_SEPARATORS) {
+		    std::string tmp("Too many fields. Expected ");
+		    tmp += num_fields_str;
+		    tmp += " fields.";
+		    logError(lineno, tmp );
+		    scan_error = true;
+		    break;
+		}
+		field_values[current_field] = l.substr(last_sep, it - last_sep);
+		cleanupValue(field_values[current_field]);
+		last_sep = it + 1;
+		current_field++;
+	    }
 	}
-	if (countSeparator(l) < NUM_SEPARATORS) {
+
+	if (scan_error) continue;
+
+	// Make sure the last field will be extracted too, but check if the
+	// last separator has any value followed.
+	if (it > last_sep) {
+	    field_values[current_field] = l.substr(last_sep, it - last_sep);
+	    cleanupValue(field_values[current_field]);
+	}
+
+	if (!inquote && (num_sep_found < NUM_SEPARATORS) ) {
 	    std::string tmp("Too few fields. Expected ");
 	    tmp += num_fields_str;
 	    tmp += " fields.";
@@ -188,26 +225,17 @@
 	    continue;
 	}
 
-	getSeparatorPos(l, seppos);
-	if (seppos.size() == 0) {
-	    logError(lineno, "Unable to identify separators.");
-	    continue;
+	if (!inquote && (num_sep_found == NUM_SEPARATORS) ) {
+	    YAPET::Record<YAPET::PasswordRecord> record;
+	    YAPET::PasswordRecord *ptr_rec = record;
+	    strncpy((char*)ptr_rec->name, field_values[0].c_str(), YAPET::NAME_SIZE);
+	    strncpy((char*)ptr_rec->host, field_values[1].c_str(), YAPET::HOST_SIZE);
+	    strncpy((char*)ptr_rec->username, field_values[2].c_str(), YAPET::USERNAME_SIZE);
+	    strncpy((char*)ptr_rec->password, field_values[3].c_str(), YAPET::PASSWORD_SIZE);
+	    strncpy((char*)ptr_rec->comment, field_values[4].c_str(), YAPET::COMMENT_SIZE);
+	    list.push_back(YAPET::PartDec(record, key));
+	    if (verbose) std::cout << ".";
 	}
-
-	std::string name = l.substr(0, seppos[0]);
-	std::string host = l.substr(seppos[0]+1, seppos[1] - seppos[0] - 1);
-	std::string uname = l.substr(seppos[1]+1, seppos[2] - seppos[1] - 1);
-	std::string passwd = l.substr(seppos[2]+1, seppos[3] - seppos[2] - 1 );
-	std::string comment = l.substr(seppos[3]+1, l.length() - seppos[3]);
-	YAPET::Record<YAPET::PasswordRecord> record;
-	YAPET::PasswordRecord *ptr_rec = record;
-	strncpy((char*)ptr_rec->name, name.c_str(), YAPET::NAME_SIZE);
-	strncpy((char*)ptr_rec->host, host.c_str(), YAPET::HOST_SIZE);
-	strncpy((char*)ptr_rec->username, uname.c_str(), YAPET::USERNAME_SIZE);
-	strncpy((char*)ptr_rec->password, passwd.c_str(), YAPET::PASSWORD_SIZE);
-	strncpy((char*)ptr_rec->comment, comment.c_str(), YAPET::COMMENT_SIZE);
-	list.push_back(YAPET::PartDec(record, key));
-	if (verbose) std::cout << ".";
     }
     if (verbose) std::cout << std::endl;
     yapetfile.save(list);
diff -ruN yapet-0.4.bak/csv2yapet/csvimport.h yapet-0.4/csv2yapet/csvimport.h
--- yapet-0.4.bak/csv2yapet/csvimport.h	2009-07-10 20:36:44.000000000 +0200
+++ yapet-0.4/csv2yapet/csvimport.h	2009-07-18 21:02:10.224663449 +0200
@@ -36,32 +36,29 @@
 # include <stdexcept>
 #endif
 
-#ifdef HAVE_VECTOR
-# include <vector>
-#endif
-
 #ifdef HAVE_LIST
 # include <list>
 #endif
 
 /**
- * Log entry.
+ * The class taking care of converting a csv file.
  */
-struct LogEntry {
-	/**
-	 * The line number where the error occurred.
-	 */
-	unsigned int lineno;
+class CSVImport {
+    public:
 	/**
-	 * The error message.
+	 * Log entry.
 	 */
-	std::string message;
-};
+	struct LogEntry {
+		/**
+		 * The line number where the error occurred.
+		 */
+		unsigned int lineno;
+		/**
+		 * The error message.
+		 */
+		std::string message;
+	};
 
-/**
- * The class taking care of converting a csv file.
- */
-class CSVImport {
     private:
 	/**
 	 * Object assignment not allowed.
@@ -110,11 +107,8 @@
 	 */
 	std::list<LogEntry> logs;
 
-	//! Count the separators of the line provided.
-	unsigned int countSeparator(const std::string& s) const;
-	//! Returns the position of the separators in the line.
-	void getSeparatorPos(const std::string& line,
-			     std::vector<std::string::size_type>& posvec) const;
+	//! Cleanup the field values
+	void cleanupValue(std::string& str);
 	//! Log the given error
 	void logError(unsigned long lno, const std::string& errmsg);
 
diff -ruN yapet-0.4.bak/doc/csv2yapet.sgml yapet-0.4/doc/csv2yapet.sgml
--- yapet-0.4.bak/doc/csv2yapet.sgml	2009-07-12 13:13:31.000000000 +0200
+++ yapet-0.4/doc/csv2yapet.sgml	2009-07-18 23:18:45.424684272 +0200
@@ -2,11 +2,11 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	  "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd"
 [
-<!ENTITY cpr SYSTEM "/home/java/yapet/doc/copyright.sgml">
-<!ENTITY supplatforms SYSTEM "/home/java/yapet/doc/supportedplatforms.sgml">
-<!ENTITY pwrecord SYSTEM "/home/java/yapet/doc/pwrecord.sgml">
-<!ENTITY caution SYSTEM "/home/java/yapet/doc/caution.sgml">
-<!ENTITY license SYSTEM "/home/java/yapet/doc/license.sgml">
+<!ENTITY cpr SYSTEM "./copyright.sgml">
+<!ENTITY supplatforms SYSTEM "./supportedplatforms.sgml">
+<!ENTITY pwrecord SYSTEM "./pwrecord.sgml">
+<!ENTITY caution SYSTEM "./caution.sgml">
+<!ENTITY license SYSTEM "./license.sgml">
 <!ENTITY OPENSSL "<citerefentry><refentrytitle>ssl</refentrytitle>
 <manvolnum>3</manvolnum></citerefentry>">
 <!ENTITY CRYPTO "<citerefentry><refentrytitle>crypto</refentrytitle>
@@ -224,10 +224,14 @@
     the <option>-s</option> option (refer to <xref linkend="options"
     />).</para>
 
-    <para>Fields containing the field separator character will lead to import
-    errors (see also <xref linkend="bugs" />).</para>
+    <para>Fields containing the field separator character have to be enclosed
+    in double quotes (").</para>
 
-    <para>The following table will describe the format of the source CSV file
+    <para>Double quote characters to be converted literally, has each to be
+    preceded by another double quote character (see <xref linkend="examples"
+    />).</para>
+
+    <para>The following table will describe the fields of the source CSV file
     as expected by &csv2yapet;:</para>
 
     <table pgwide="1">
@@ -346,15 +350,7 @@
   <refsect1 id="bugs">
     <title>BUGS</title>
 
-    <itemizedlist>
-      <listitem>
-	  <para>If the field separating character is part of the field value,
-	  it is misinterpreted as field delimiter.</para>
-      </listitem>
-    </itemizedlist>
-
-
-    <para>Please report other bugs to the author (see <xref linkend="author"
+    <para>Please report bugs to the author (see <xref linkend="author"
     />).</para>
 
   </refsect1>
@@ -368,11 +364,14 @@
   <refsect1 id="examples">
     <title>EXAMPLES</title>
 
-    <example id="ex.csv">
+    <example id="ex.csv1">
       <title>An example of a CSV file accepted by &csv2yapet;.</title>
 
       <para>The following example shows an excerpt of a CSV file as accepted
       for conversion by &csv2yapet;.</para>
+
+      <para>As the second line shows, fields can be blank but the separator may
+      not be omitted.</para>
 <screen>
 ssh host,host.example.org,johndoe,secret,linux machine
 mail account,imap.email.org,john_doe,secret,
@@ -380,6 +379,23 @@
 </screen>
     </example>
 
+    <example id="ex.csv2">
+      <title>An example of a CSV file accepted by &csv2yapet; using double quotes.</title>
+
+      <para>The following example shows an excerpt of a CSV file as accepted
+      for conversion by &csv2yapet;.</para>
+
+      <para>The first line demonstrates how to double quote fields containing
+      the separator character. The second line shows how to literally convert
+      double quote characters.</para>
+
+<screen>
+"ssh, ftp, and http server",server.example.org,johndoe,secret,linux machine
+mail account,imap.email.org,john_doe,secret,"John ""the Unknown"" Doe"
+&hellip;
+</screen>
+    </example>
+
     <example id="ex.invoc1">
       <title>Invoking &csv2yapet;.</title>
 
diff -ruN yapet-0.4.bak/doc/csv2yapet.sgml.in yapet-0.4/doc/csv2yapet.sgml.in
--- yapet-0.4.bak/doc/csv2yapet.sgml.in	2009-07-12 12:55:27.000000000 +0200
+++ yapet-0.4/doc/csv2yapet.sgml.in	2009-07-18 23:07:29.888683758 +0200
@@ -224,10 +224,14 @@
     the <option>-s</option> option (refer to <xref linkend="options"
     />).</para>
 
-    <para>Fields containing the field separator character will lead to import
-    errors (see also <xref linkend="bugs" />).</para>
+    <para>Fields containing the field separator character have to be enclosed
+    in double quotes (").</para>
 
-    <para>The following table will describe the format of the source CSV file
+    <para>Double quote characters to be converted literally, has each to be
+    preceded by another double quote character (see <xref linkend="examples"
+    />).</para>
+
+    <para>The following table will describe the fields of the source CSV file
     as expected by &csv2yapet;:</para>
 
     <table pgwide="1">
@@ -346,15 +350,7 @@
   <refsect1 id="bugs">
     <title>BUGS</title>
 
-    <itemizedlist>
-      <listitem>
-	  <para>If the field separating character is part of the field value,
-	  it is misinterpreted as field delimiter.</para>
-      </listitem>
-    </itemizedlist>
-
-
-    <para>Please report other bugs to the author (see <xref linkend="author"
+    <para>Please report bugs to the author (see <xref linkend="author"
     />).</para>
 
   </refsect1>
@@ -368,11 +364,14 @@
   <refsect1 id="examples">
     <title>EXAMPLES</title>
 
-    <example id="ex.csv">
+    <example id="ex.csv1">
       <title>An example of a CSV file accepted by &csv2yapet;.</title>
 
       <para>The following example shows an excerpt of a CSV file as accepted
       for conversion by &csv2yapet;.</para>
+
+      <para>As the second line shows, fields can be blank but the separator may
+      not be omitted.</para>
 <screen>
 ssh host,host.example.org,johndoe,secret,linux machine
 mail account,imap.email.org,john_doe,secret,
@@ -380,6 +379,23 @@
 </screen>
     </example>
 
+    <example id="ex.csv2">
+      <title>An example of a CSV file accepted by &csv2yapet; using double quotes.</title>
+
+      <para>The following example shows an excerpt of a CSV file as accepted
+      for conversion by &csv2yapet;.</para>
+
+      <para>The first line demonstrates how to double quote fields containing
+      the separator character. The second line shows how to literally convert
+      double quote characters.</para>
+
+<screen>
+"ssh, ftp, and http server",server.example.org,johndoe,secret,linux machine
+mail account,imap.email.org,john_doe,secret,"John ""the Unknown"" Doe"
+&hellip;
+</screen>
+    </example>
+
     <example id="ex.invoc1">
       <title>Invoking &csv2yapet;.</title>
 
diff -ruN yapet-0.4.bak/doc/DESIGN.sgml yapet-0.4/doc/DESIGN.sgml
--- yapet-0.4.bak/doc/DESIGN.sgml	2009-07-12 13:13:31.000000000 +0200
+++ yapet-0.4/doc/DESIGN.sgml	2009-07-18 23:18:45.372663454 +0200
@@ -2,9 +2,9 @@
 <!DOCTYPE article PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd"
 [
-<!ENTITY cpr SYSTEM "/home/java/yapet/doc/copyright.sgml">
-<!ENTITY supplatforms SYSTEM "/home/java/yapet/doc/supportedplatforms.sgml">
-<!ENTITY pwrecord SYSTEM "/home/java/yapet/doc/pwrecord.sgml">
+<!ENTITY cpr SYSTEM "./copyright.sgml">
+<!ENTITY supplatforms SYSTEM "./supportedplatforms.sgml">
+<!ENTITY pwrecord SYSTEM "./pwrecord.sgml">
 <!ENTITY OPENSSL "<citerefentry><refentrytitle>ssl</refentrytitle>
 <manvolnum>3</manvolnum></citerefentry>">
 <!ENTITY CRYPTO "<citerefentry><refentrytitle>crypto</refentrytitle>
diff -ruN yapet-0.4.bak/doc/INSTALL.sgml yapet-0.4/doc/INSTALL.sgml
--- yapet-0.4.bak/doc/INSTALL.sgml	2009-07-12 13:13:31.000000000 +0200
+++ yapet-0.4/doc/INSTALL.sgml	2009-07-18 23:18:45.272622909 +0200
@@ -2,9 +2,9 @@
 <!DOCTYPE article PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	  "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd"
 [
-<!ENTITY cpr SYSTEM "/home/java/yapet/doc/copyright.sgml">
-<!ENTITY preamble SYSTEM "/home/java/yapet/doc/preamble.sgml">
-<!ENTITY supplatforms SYSTEM "/home/java/yapet/doc/supportedplatforms.sgml">
+<!ENTITY cpr SYSTEM "./copyright.sgml">
+<!ENTITY preamble SYSTEM "./preamble.sgml">
+<!ENTITY supplatforms SYSTEM "./supportedplatforms.sgml">
 <!ENTITY OPENSSL "<citerefentry><refentrytitle>ssl</refentrytitle>
 <manvolnum>3</manvolnum></citerefentry>">
 <!ENTITY CURSES "<citerefentry><refentrytitle>curses</refentrytitle>
diff -ruN yapet-0.4.bak/doc/README.Cygwin.sgml yapet-0.4/doc/README.Cygwin.sgml
--- yapet-0.4.bak/doc/README.Cygwin.sgml	2009-07-12 13:13:31.000000000 +0200
+++ yapet-0.4/doc/README.Cygwin.sgml	2009-07-18 23:18:45.196663493 +0200
@@ -2,9 +2,9 @@
 <!DOCTYPE article PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	  "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd"
 [
-<!ENTITY cpr SYSTEM "/home/java/yapet/doc/copyright.sgml">
-<!ENTITY supplatforms SYSTEM "/home/java/yapet/doc/supportedplatforms.sgml">
-<!ENTITY caution SYSTEM "/home/java/yapet/doc/caution.sgml">
+<!ENTITY cpr SYSTEM "./copyright.sgml">
+<!ENTITY supplatforms SYSTEM "./supportedplatforms.sgml">
+<!ENTITY caution SYSTEM "./caution.sgml">
 <!ENTITY OPENSSL "<citerefentry><refentrytitle>ssl</refentrytitle>
 <manvolnum>3</manvolnum></citerefentry>">
 <!ENTITY CURSES "<citerefentry><refentrytitle>curses</refentrytitle>
diff -ruN yapet-0.4.bak/doc/README.sgml yapet-0.4/doc/README.sgml
--- yapet-0.4.bak/doc/README.sgml	2009-07-12 13:13:31.000000000 +0200
+++ yapet-0.4/doc/README.sgml	2009-07-18 23:18:45.108663552 +0200
@@ -2,10 +2,10 @@
 <!DOCTYPE article PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	  "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd"
 [
-<!ENTITY cpr SYSTEM "/home/java/yapet/doc/copyright.sgml">
-<!ENTITY supplatforms SYSTEM "/home/java/yapet/doc/supportedplatforms.sgml">
-<!ENTITY caution SYSTEM "/home/java/yapet/doc/caution.sgml">
-<!ENTITY license SYSTEM "/home/java/yapet/doc/license.sgml">
+<!ENTITY cpr SYSTEM "./copyright.sgml">
+<!ENTITY supplatforms SYSTEM "./supportedplatforms.sgml">
+<!ENTITY caution SYSTEM "./caution.sgml">
+<!ENTITY license SYSTEM "./license.sgml">
 <!ENTITY OPENSSL "<citerefentry><refentrytitle>ssl</refentrytitle>
 <manvolnum>3</manvolnum></citerefentry>">
 <!ENTITY CURSES "<citerefentry><refentrytitle>curses</refentrytitle>
diff -ruN yapet-0.4.bak/doc/yapet.sgml yapet-0.4/doc/yapet.sgml
--- yapet-0.4.bak/doc/yapet.sgml	2009-07-12 13:13:31.000000000 +0200
+++ yapet-0.4/doc/yapet.sgml	2009-07-18 23:18:45.044654275 +0200
@@ -2,11 +2,11 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	  "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd"
 [
-<!ENTITY cpr SYSTEM "/home/java/yapet/doc/copyright.sgml">
-<!ENTITY supplatforms SYSTEM "/home/java/yapet/doc/supportedplatforms.sgml">
-<!ENTITY pwrecord SYSTEM "/home/java/yapet/doc/pwrecord.sgml">
-<!ENTITY caution SYSTEM "/home/java/yapet/doc/caution.sgml">
-<!ENTITY license SYSTEM "/home/java/yapet/doc/license.sgml">
+<!ENTITY cpr SYSTEM "./copyright.sgml">
+<!ENTITY supplatforms SYSTEM "./supportedplatforms.sgml">
+<!ENTITY pwrecord SYSTEM "./pwrecord.sgml">
+<!ENTITY caution SYSTEM "./caution.sgml">
+<!ENTITY license SYSTEM "./license.sgml">
 <!ENTITY OPENSSL "<citerefentry><refentrytitle>ssl</refentrytitle>
 <manvolnum>3</manvolnum></citerefentry>">
 <!ENTITY CRYPTO "<citerefentry><refentrytitle>crypto</refentrytitle>
diff -ruN yapet-0.4.bak/tests/import10.cc yapet-0.4/tests/import10.cc
--- yapet-0.4.bak/tests/import10.cc	1970-01-01 01:00:00.000000000 +0100
+++ yapet-0.4/tests/import10.cc	2009-07-18 22:10:17.144663477 +0200
@@ -0,0 +1,53 @@
+// $Id$
+// Checks whether or not the import of import9 worked.
+// Relies on test6.csv
+
+#include <string.h>
+
+#include <iostream>
+
+#include <key.h>
+#include <crypt.h>
+#include <structs.h>
+#include <record.h>
+#include <partdec.h>
+#include <file.h>
+
+// Keep them define's here, since tests.h only defines the default if they are
+// not predefined
+#define ROUNDS 200
+#define NAME "\"Test name %d"
+#define HOST "Test host %d\""
+#define UNAME "Test \"username %d"
+#define PW "Test \"password\" %d"
+#define COMMENT "Test \"\"comment %d\"\""
+
+#include "tests.h"
+#include "testpaths.h"
+
+int main(int, char**) {
+    std::cout << "Check if import9 worked... " << std::endl;
+    try {
+	YAPET::Key key("test6");
+	YAPET::File file("test6.pet", key, false);
+	std::list<YAPET::PartDec> list = file.read(key);
+	if (list.size() != ROUNDS) {
+	    std::cout << "no" << std::endl;
+	    return 1;
+	}
+
+	std::list<YAPET::PartDec>::iterator it = list.begin();
+
+	for(int i=0; it != list.end(); i++) {
+	    check_record(*it, key, i);
+	    it++;
+	}
+
+    } catch (std::exception& ex) {
+	std::cout << "no" << std::endl;
+	std::cout << ex.what() << std::endl;
+	return 1;
+    }
+    std::cout << "yes" << std::endl;
+    return 0;
+}
diff -ruN yapet-0.4.bak/tests/import11.cc yapet-0.4/tests/import11.cc
--- yapet-0.4.bak/tests/import11.cc	1970-01-01 01:00:00.000000000 +0100
+++ yapet-0.4/tests/import11.cc	2009-07-18 22:31:05.892663481 +0200
@@ -0,0 +1,35 @@
+// $Id$
+//
+// Tests whether or not import works with double quoted values and embedded
+// delimiters
+//
+// Relies on test7.csv
+
+#ifdef HAVE_CONFIG_H
+# include <config.h>
+#endif
+
+#ifdef HAVE_IOSTREAM
+# include <iostream>
+#endif
+
+#include <csvimport.h>
+
+#include "testpaths.h"
+
+int main (int, char**) {
+    try {
+	std::cout << "Importing from test7.csv" << std::endl;;
+	CSVImport imp(SRCDIR "/test7.csv", "test7.pet", ',');
+	imp.import("test7");
+	if (imp.hadErrors())
+	    return 1;
+	if (imp.numErrors() != 0)
+	    return 1;
+    } catch(std::exception& ex) {
+	std::cout << ex.what() << std::endl;
+	return 1;
+    }
+
+    return 0;
+}
diff -ruN yapet-0.4.bak/tests/import12.cc yapet-0.4/tests/import12.cc
--- yapet-0.4.bak/tests/import12.cc	1970-01-01 01:00:00.000000000 +0100
+++ yapet-0.4/tests/import12.cc	2009-07-18 22:32:22.484663466 +0200
@@ -0,0 +1,53 @@
+// $Id$
+// Checks whether or not the import of import10 worked.
+// Relies on test7.csv
+
+#include <string.h>
+
+#include <iostream>
+
+#include <key.h>
+#include <crypt.h>
+#include <structs.h>
+#include <record.h>
+#include <partdec.h>
+#include <file.h>
+
+// Keep them define's here, since tests.h only defines the default if they are
+// not predefined
+#define ROUNDS 200
+#define NAME ",Test name %d"
+#define HOST "Test, host %d"
+#define UNAME "Test username, %d"
+#define PW "Test password %d"
+#define COMMENT "Test comment %d,"
+
+#include "tests.h"
+#include "testpaths.h"
+
+int main(int, char**) {
+    std::cout << "Check if import11 worked... " << std::endl;
+    try {
+	YAPET::Key key("test7");
+	YAPET::File file("test7.pet", key, false);
+	std::list<YAPET::PartDec> list = file.read(key);
+	if (list.size() != ROUNDS) {
+	    std::cout << "no" << std::endl;
+	    return 1;
+	}
+
+	std::list<YAPET::PartDec>::iterator it = list.begin();
+
+	for(int i=0; it != list.end(); i++) {
+	    check_record(*it, key, i);
+	    it++;
+	}
+
+    } catch (std::exception& ex) {
+	std::cout << "no" << std::endl;
+	std::cout << ex.what() << std::endl;
+	return 1;
+    }
+    std::cout << "yes" << std::endl;
+    return 0;
+}
diff -ruN yapet-0.4.bak/tests/import13.cc yapet-0.4/tests/import13.cc
--- yapet-0.4.bak/tests/import13.cc	1970-01-01 01:00:00.000000000 +0100
+++ yapet-0.4/tests/import13.cc	2009-07-18 22:41:40.572663472 +0200
@@ -0,0 +1,40 @@
+// $Id$
+//
+// Tests the error detection when double quoting is wrong.
+//
+// Relies on test8.csv
+
+#ifdef HAVE_CONFIG_H
+# include <config.h>
+#endif
+
+#ifdef HAVE_IOSTREAM
+# include <iostream>
+#endif
+
+
+#include <csvimport.h>
+#include "testpaths.h"
+
+int main (int, char**) {
+    try {
+	std::cout << "Importing from test8.csv" << std::endl;
+	std::cout << "Testing for error recognition" << std::endl;
+	CSVImport imp(SRCDIR "/test8.csv", "test8.pet", ',');
+	imp.import("test8");
+	imp.printLog();
+	if (imp.numErrors() != 1)
+	    return 1;
+	std::list<CSVImport::LogEntry> logs(imp.getLog());
+	if (logs.size() != 1)
+	    return 1;
+	std::list<CSVImport::LogEntry>::const_iterator it = logs.begin();
+	if ((*it).lineno != 3)
+	    return 1;
+    } catch(std::exception& ex) {
+	std::cout << ex.what() << std::endl;
+	return 1;
+    }
+
+    return 0;
+}
diff -ruN yapet-0.4.bak/tests/import14.cc yapet-0.4/tests/import14.cc
--- yapet-0.4.bak/tests/import14.cc	1970-01-01 01:00:00.000000000 +0100
+++ yapet-0.4/tests/import14.cc	2009-07-18 22:48:32.520663478 +0200
@@ -0,0 +1,38 @@
+// $Id$
+//
+// Tests whether or not strange input make the import choke (using double
+// quotes)
+//
+// Relies on test9.csv
+
+#ifdef HAVE_CONFIG_H
+# include <config.h>
+#endif
+
+#ifdef HAVE_IOSTREAM
+# include <iostream>
+#endif
+
+
+#include <csvimport.h>
+#include "testpaths.h"
+
+int main (int, char**) {
+    try {
+	std::cout << "Importing from test9.csv" << std::endl;
+	std::cout << "Testing import of strange things" << std::endl;
+	CSVImport imp( SRCDIR "/test9.csv", "test9.pet", ',');
+	imp.import("test9");
+	if (imp.hadErrors()) {
+	    imp.printLog();
+	    return 1;
+	}
+	if (imp.numErrors() != 0)
+	    return 1;
+    } catch(std::exception& ex) {
+	std::cout << ex.what() << std::endl;
+	return 1;
+    }
+
+    return 0;
+}
diff -ruN yapet-0.4.bak/tests/import2.cc yapet-0.4/tests/import2.cc
--- yapet-0.4.bak/tests/import2.cc	2009-07-07 21:05:34.000000000 +0200
+++ yapet-0.4/tests/import2.cc	2009-07-18 20:16:46.180643271 +0200
@@ -22,13 +22,15 @@
 #define ROUNDS 200
 
 int main(int, char**) {
-    std::cout << "Check if import1 worked" << std::endl;
+    std::cout << "Check if import1 worked... " << std::endl;
     try {
 	YAPET::Key key("test1");
 	YAPET::File file("test1.pet", key, false);
 	std::list<YAPET::PartDec> list = file.read(key);
-	if (list.size() != ROUNDS)
+	if (list.size() != ROUNDS) {
+	    std::cout << "no" << std::endl;
 	    return 1;
+	}
 
 	std::list<YAPET::PartDec>::iterator it = list.begin();
 
@@ -38,8 +40,10 @@
 	}
 
     } catch (std::exception& ex) {
+	std::cout << "no" << std::endl;
 	std::cout << ex.what() << std::endl;
 	return 1;
     }
+    std::cout << "yes" << std::endl;
     return 0;
 }
diff -ruN yapet-0.4.bak/tests/import3.cc yapet-0.4/tests/import3.cc
--- yapet-0.4.bak/tests/import3.cc	2009-07-08 00:20:11.000000000 +0200
+++ yapet-0.4/tests/import3.cc	2009-07-17 19:39:49.840704022 +0200
@@ -23,10 +23,10 @@
 	imp.printLog();
 	if (imp.numErrors() != 2)
 	    return 1;
-	std::list<LogEntry> logs(imp.getLog());
+	std::list<CSVImport::LogEntry> logs(imp.getLog());
 	if (logs.size() != 2)
 	    return 1;
-	std::list<LogEntry>::const_iterator it = logs.begin();
+	std::list<CSVImport::LogEntry>::const_iterator it = logs.begin();
 	if ((*it).lineno != 2)
 	    return 1;
 	it++;
diff -ruN yapet-0.4.bak/tests/import7.cc yapet-0.4/tests/import7.cc
--- yapet-0.4.bak/tests/import7.cc	1970-01-01 01:00:00.000000000 +0100
+++ yapet-0.4/tests/import7.cc	2009-07-18 20:35:24.344663767 +0200
@@ -0,0 +1,32 @@
+// $Id$
+// Tests whether or not import works with double quoted values
+// Relies on test5.csv
+
+#ifdef HAVE_CONFIG_H
+# include <config.h>
+#endif
+
+#ifdef HAVE_IOSTREAM
+# include <iostream>
+#endif
+
+#include <csvimport.h>
+
+#include "testpaths.h"
+
+int main (int, char**) {
+    try {
+	std::cout << "Importing from test5.csv" << std::endl;;
+	CSVImport imp(SRCDIR "/test5.csv", "test5.pet", ',');
+	imp.import("test5");
+	if (imp.hadErrors())
+	    return 1;
+	if (imp.numErrors() != 0)
+	    return 1;
+    } catch(std::exception& ex) {
+	std::cout << ex.what() << std::endl;
+	return 1;
+    }
+
+    return 0;
+}
diff -ruN yapet-0.4.bak/tests/import8.cc yapet-0.4/tests/import8.cc
--- yapet-0.4.bak/tests/import8.cc	1970-01-01 01:00:00.000000000 +0100
+++ yapet-0.4/tests/import8.cc	2009-07-18 21:18:24.164623033 +0200
@@ -0,0 +1,49 @@
+// $Id$
+// Checks whether or not the import of import7 worked.
+// Relies on test5.csv
+
+#include <string.h>
+
+#include <iostream>
+
+#include <key.h>
+#include <crypt.h>
+#include <structs.h>
+#include <record.h>
+#include <partdec.h>
+#include <file.h>
+
+#include "tests.h"
+#include "testpaths.h"
+
+#ifdef ROUNDS
+#undef ROUNDS
+#endif
+#define ROUNDS 200
+
+int main(int, char**) {
+    std::cout << "Check if import7 worked... " << std::endl;
+    try {
+	YAPET::Key key("test5");
+	YAPET::File file("test5.pet", key, false);
+	std::list<YAPET::PartDec> list = file.read(key);
+	if (list.size() != ROUNDS) {
+	    std::cout << "no" << std::endl;
+	    return 1;
+	}
+
+	std::list<YAPET::PartDec>::iterator it = list.begin();
+
+	for(int i=0; it != list.end(); i++) {
+	    check_record(*it, key, i);
+	    it++;
+	}
+
+    } catch (std::exception& ex) {
+	std::cout << "no" << std::endl;
+	std::cout << ex.what() << std::endl;
+	return 1;
+    }
+    std::cout << "yes" << std::endl;
+    return 0;
+}
diff -ruN yapet-0.4.bak/tests/import9.cc yapet-0.4/tests/import9.cc
--- yapet-0.4.bak/tests/import9.cc	1970-01-01 01:00:00.000000000 +0100
+++ yapet-0.4/tests/import9.cc	2009-07-18 21:17:29.196663498 +0200
@@ -0,0 +1,35 @@
+// $Id$
+//
+// Tests whether or not import works with double quoted values and escaped
+// double quotes.
+//
+// Relies on test6.csv
+
+#ifdef HAVE_CONFIG_H
+# include <config.h>
+#endif
+
+#ifdef HAVE_IOSTREAM
+# include <iostream>
+#endif
+
+#include <csvimport.h>
+
+#include "testpaths.h"
+
+int main (int, char**) {
+    try {
+	std::cout << "Importing from test6.csv" << std::endl;;
+	CSVImport imp(SRCDIR "/test6.csv", "test6.pet", ',');
+	imp.import("test6");
+	if (imp.hadErrors())
+	    return 1;
+	if (imp.numErrors() != 0)
+	    return 1;
+    } catch(std::exception& ex) {
+	std::cout << ex.what() << std::endl;
+	return 1;
+    }
+
+    return 0;
+}
